moSetGetClientSettings = {};

function moSetGetClientSettings:loadConfig(self, Xml, xmlNameTag, file, isSaveGameIndex, appFile) --appFile for backupXML appSettings(wird später(hier) ausgeführt weil sonst die preview app icons fehlen
	moGeneralSettings.clientSettingsXml = Xml;
	
	--other settings
	local groupNameTag = (xmlNameTag.. ".other(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#miniMapAutoState0") ~= nil then moGeneralSettings.other.miniMapAutoState0 = getXMLBool(Xml, groupNameTag.. "#miniMapAutoState0");end;	
	if getXMLBool(Xml, groupNameTag.. "#playerPos") ~= nil then moGeneralSettings.playerPos = getXMLBool(Xml, groupNameTag.. "#playerPos");end;
	--other settings
	--wtm settings
	groupNameTag = (xmlNameTag.. ".wtm(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#weatherBox") ~= nil then MultiOverlayV3.wtm.weatherBox = getXMLBool(Xml, groupNameTag.. "#weatherBox");end;
	if getXMLBool(Xml, groupNameTag.. "#moneyBox") ~= nil then MultiOverlayV3.wtm.showMoney = getXMLBool(Xml, groupNameTag.. "#moneyBox");end;
	if getXMLBool(Xml, groupNameTag.. "#timeBox") ~= nil then MultiOverlayV3.wtm.showTime= getXMLBool(Xml, groupNameTag.. "#timeBox");end;
	if getXMLBool(Xml, groupNameTag.. "#seasonBox") ~= nil then MultiOverlayV3.wtm.seasonBox = getXMLBool(Xml, groupNameTag.. "#seasonBox");end;
	if getXMLBool(Xml, groupNameTag.. "#stateBox") ~= nil then MultiOverlayV3.wtm.stateBox = getXMLBool(Xml, groupNameTag.. "#stateBox");end;
	if getXMLBool(Xml, groupNameTag.. "#temperatureBox") ~= nil then MultiOverlayV3.wtm.temperatureBox = getXMLBool(Xml, groupNameTag.. "#temperatureBox");end;
	--wtm settings
	--side notifications
	groupNameTag = (xmlNameTag.. ".sideNotifications(%d)"):format(0);
	if getXMLInt(Xml, groupNameTag.. "#viewMax") then moGeneralSettings.sideNotifications.viewMax = getXMLInt(Xml, groupNameTag.. "#viewMax");end;
	if moGeneralSettings.sideNotifications.viewMax > 10 or moGeneralSettings.sideNotifications.viewMax < 1 then moGeneralSettings.sideNotifications.viewMax = 5;end;
	if getXMLInt(Xml, groupNameTag.. "#upDownFix") then moGeneralSettings.sideNotifications.upDownFix = getXMLInt(Xml, groupNameTag.. "#upDownFix");end;
	if moGeneralSettings.sideNotifications.upDownFix > 10 or moGeneralSettings.sideNotifications.upDownFix < -10 then moGeneralSettings.sideNotifications.upDownFix = 0;end;
	if getXMLInt(Xml, groupNameTag.. "#duration") then moGeneralSettings.sideNotifications.duration = getXMLInt(Xml, groupNameTag.. "#duration");end;
	if moGeneralSettings.sideNotifications.duration > 1000 or moGeneralSettings.sideNotifications.duration < 100 then moGeneralSettings.sideNotifications.duration = 500;end;
	--side notifications
	--global mod
	groupNameTag = (xmlNameTag.. ".global.mod(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#on") ~= nil then moGeneralSettings.modOn = getXMLBool(Xml, groupNameTag.. "#on");end;	
	if getXMLBool(Xml, groupNameTag.. "#mouseOnAndFrozen") ~= nil then moSetGetOverlays.setFrozen = getXMLBool(Xml, groupNameTag.. "#mouseOnAndFrozen");end;
	if getXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto") ~= nil then moGeneralSettings.screenAspectRatioAuto = getXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto");end;
	if not moGeneralSettings.scrreenAspectRatioAuto then
		if getXMLInt(Xml, groupNameTag.. "#screenAspectRatio") then moSetGetOverlays.screenAspectRatio = getXMLInt(Xml, groupNameTag.. "#screenAspectRatio");end;
	else
		moSetGetOverlays:setScreenAspectRatio(self);
	end;
	if getXMLBool(Xml, groupNameTag.. "#backupClientSetting") ~= nil then moGeneralSettings.backupSettings.clientSetting = getXMLBool(Xml, groupNameTag.. "#backupClientSetting");end;
	if getXMLBool(Xml, groupNameTag.. "#backupAppSetting") ~= nil then moGeneralSettings.backupSettings.appSetting = getXMLBool(Xml, groupNameTag.. "#backupAppSetting");end;
	if getXMLBool(Xml, groupNameTag.. "#deleteConfirm") ~= nil then moGeneralSettings.deleteConfirm = getXMLBool(Xml, groupNameTag.. "#deleteConfirm");end;
	if getXMLBool(Xml, groupNameTag.. "#mouseCursorAutoOff") ~= nil then moGeneralSettings.autoMouseCursor.off = getXMLBool(Xml, groupNameTag.. "#mouseCursorAutoOff");end;	
	if getXMLInt(Xml, groupNameTag.. "#mouseCursorOffTimer") then moGeneralSettings.autoMouseCursor.timer = getXMLInt(Xml, groupNameTag.. "#mouseCursorOffTimer");end;
	if moGeneralSettings.autoMouseCursor.timer > 10 then moGeneralSettings.autoMouseCursor.timer = 10;elseif moGeneralSettings.autoMouseCursor.timer < 2 then moGeneralSettings.autoMouseCursor.timer = 2;end;
	if getXMLBool(Xml, groupNameTag.. "#hlDebugMode") ~= nil then MultiOverlayV3.hlDebugMode = getXMLBool(Xml, groupNameTag.. "#hlDebugMode");end;	
	--global mod
		
	--global PDAs
	groupNameTag = (xmlNameTag.. ".global.pda(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#invisible") ~= nil then moGeneralSettings.invisible.pdas = getXMLBool(Xml, groupNameTag.. "#invisible");end;
	if getXMLInt(Xml, groupNameTag.. "#pdaTotal") then moGeneralSettings.pdaTotal = getXMLInt(Xml, groupNameTag.. "#pdaTotal");end;
	if getXMLBool(Xml, groupNameTag.. "#ignoreMaxViewLines") ~= nil then moGeneralSettings.ignore.maxViewLines = getXMLBool(Xml, groupNameTag.. "#ignoreMaxViewLines");end;
	if moGeneralSettings.ignore.maxViewLines then moGeneralSettings.ignore.maxViewLinesXml = true;end;	
	if getXMLBool(Xml, groupNameTag.. "#ignoreMaxViewApps") ~= nil then moGeneralSettings.ignore.maxViewApps = getXMLBool(Xml, groupNameTag.. "#ignoreMaxViewApps");end;
	if moGeneralSettings.ignore.maxViewApps then moGeneralSettings.ignore.maxViewAppsXml = true;end;	
	if getXMLBool(Xml, groupNameTag.. "#ignoreMaxAppsAtLine") ~= nil then moGeneralSettings.ignore.maxAppsAtLine = getXMLBool(Xml, groupNameTag.. "#ignoreMaxAppsAtLine");end;
	if moGeneralSettings.ignore.maxAppsAtLine then moGeneralSettings.ignore.maxAppsAtLineXml = true;end;
	if getXMLBool(Xml, groupNameTag.. "#ignoreMaxZoomOutIn") ~= nil then moGeneralSettings.ignore.maxZoomOutIn = getXMLBool(Xml, groupNameTag.. "#ignoreMaxZoomOutIn");end;
	if moGeneralSettings.ignore.maxZoomOutIn then moGeneralSettings.ignore.maxZoomOutInXml = true;end;
	if getXMLBool(Xml, groupNameTag.. "#ignoreMinZoomOutIn") ~= nil then moGeneralSettings.ignore.minZoomOutIn = getXMLBool(Xml, groupNameTag.. "#ignoreMinZoomOutIn");end;
	if moGeneralSettings.ignore.minZoomOutIn then moGeneralSettings.ignore.minZoomOutInXml = true;end;	
	
	local isLoadPDA = false;		
	if getXMLString(Xml, groupNameTag.. "#pdaNamen") then
		local pdaNamen = getXMLString(Xml, groupNameTag.. "#pdaNamen");
		if string.len(pdaNamen) > 0 then
			local stringSplitTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {pdaNamen, ","}, "moSetGetClientSettings Load PdaNamen/String Split"); --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
			if isOkay and #stringSplitTable > 0 then 
				for pdaName=1, #stringSplitTable do					
					isLoadPDA = true;
					loadPDA(self, Xml, xmlNameTag, stringSplitTable[pdaName]);					
				end;				
			end;
		end;
	end;
	if not isLoadPDA then loadPDA(self, Xml, xmlNameTag, "masterPDA_");end;		
	--global PDAs
	--global SLOTs
	groupNameTag = (xmlNameTag.. ".global.slot(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#invisible") ~= nil then moGeneralSettings.invisible.slots = getXMLBool(Xml, groupNameTag.. "#invisible");end;
	if getXMLInt(Xml, groupNameTag.. "#slotTotal") then moGeneralSettings.slotTotal = getXMLInt(Xml, groupNameTag.. "#slotTotal");end;
	local isLoadSLOT = false;
	if getXMLString(Xml, groupNameTag.. "#slotNamen") then
		local slotNamen = getXMLString(Xml, groupNameTag.. "#slotNamen");
		if string.len(slotNamen) > 0 then
			local stringSplitTable, isOkay = MultiOverlayV3:get_hl("stringSplit", {slotNamen, ","}, "moSetGetClientSettings Load SlotNamen/String Split"); --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
			if isOkay and #stringSplitTable > 0 then 
				for slotName=1, #stringSplitTable do					
					isLoadSLOT = true;
					loadSLOT(self, Xml, xmlNameTag, stringSplitTable[slotName]);					
				end;				
			end;
		end;
	end;
	if not isLoadSLOT then loadSLOT(self, Xml, xmlNameTag, "masterSLOT_");end;	
	--global SLOTs
	--module
	moModule:loadConfigs(self, Xml, xmlNameTag, file, isSaveGameIndex);
	--module
	--apps
	--apps
	if not MultiOverlayV3:getServer() and moGeneralSettings.backupSettings.clientSetting then moSetGetClientSettings:saveBackup(file, isSaveGameIndex);end;
	if not MultiOverlayV3:getServer() and moGeneralSettings.backupSettings.appSetting then moSetGetAppSettings:saveBackup(moSetGetAppSettings.orginalFile[1], moSetGetAppSettings.orginalFile[2]);end;
end;

function loadPDA(self, Xml, xmlNameTag, whichPDA)
	local whichSubPDA = whichPDA;
	local groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. "(%d)"):format(0);
	if Xml ~= nil and groupNameTag ~= nil and getXMLString(Xml, groupNameTag.. "#name") ~= nil then		
		--generate default pda table
		if moSetGetOverlays.pda[whichSubPDA] == nil then moSetGetOverlays.pda[whichSubPDA] = MultiOverlayV3:getTableCopy(moSetGetOverlays.pdaDefault);end;
		--generate default pda table		
		local Xml = moGeneralSettings.clientSettingsXml;
		if getXMLString(Xml, groupNameTag.. "#name") ~= nil then moSetGetOverlays.pda[whichSubPDA].name = getXMLString(Xml, groupNameTag.. "#name");end;
		if not string.find(whichSubPDA, "masterPDA_") then
			if getXMLBool(Xml, groupNameTag.. "#isOpen") ~= nil then moSetGetOverlays.pda[whichSubPDA].isOpen = getXMLBool(Xml, groupNameTag.. "#isOpen");end;	
		end;
		if getXMLBool(Xml, groupNameTag.. "#autoClose") ~= nil then moSetGetOverlays.pda[whichSubPDA].autoClose = getXMLBool(Xml, groupNameTag.. "#autoClose");end;
		if getXMLBool(Xml, groupNameTag.. "#autoOpenCloseSettings") ~= nil then moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings = getXMLBool(Xml, groupNameTag.. "#autoOpenCloseSettings");end;
		if getXMLBool(Xml, groupNameTag.. "#autoHidden") ~= nil then moSetGetOverlays.pda[whichSubPDA].hidden.auto = getXMLBool(Xml, groupNameTag.. "#autoHidden");end;		
		if getXMLInt(Xml, groupNameTag.. "#hiddenTimer") then moSetGetOverlays.pda[whichSubPDA].hidden.timer = getXMLInt(Xml, groupNameTag.. "#hiddenTimer");end;
		if moSetGetOverlays.pda[whichSubPDA].hidden.timer > moGeneralSettings.maxTimers or moSetGetOverlays.pda[whichSubPDA].hidden.timer <= 0 then moSetGetOverlays.pda[whichSubPDA].hidden.timer = 3;end;
		--if getXMLBool(Xml, groupNameTag.. "#smallView") ~= nil then moSetGetOverlays.pda[whichSubPDA].smallView = getXMLBool(Xml, groupNameTag.. "#smallView");end;
		if getXMLBool(Xml, groupNameTag.. "#keyControl") ~= nil then moSetGetOverlays.pda[whichSubPDA].keyControl = getXMLBool(Xml, groupNameTag.. "#keyControl");end;				
		if getXMLInt(Xml, groupNameTag.. "#keySelectLine") then moSetGetOverlays.pda[whichSubPDA].keySelect.line = getXMLInt(Xml, groupNameTag.. "#keySelectLine");end;
		if getXMLInt(Xml, groupNameTag.. "#keySelectApp") then moSetGetOverlays.pda[whichSubPDA].keySelect.app = getXMLInt(Xml, groupNameTag.. "#keySelectApp");end;		
		
		groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".design");
		if getXMLInt(Xml, groupNameTag.. "#groundDesign") then moSetGetOverlays.pda[whichSubPDA].groundDesign = getXMLInt(Xml, groupNameTag.. "#groundDesign");end;
		if moSetGetOverlays.pda[whichSubPDA].groundDesign > moSetGetOverlays.groundDesignMax then moSetGetOverlays.pda[whichSubPDA].groundDesign = 1;end;
		if getXMLFloat(Xml, groupNameTag.. "#distanceAppIcons") then moSetGetOverlays.pda[whichSubPDA].distanceAppIcons = getXMLFloat(Xml, groupNameTag.. "#distanceAppIcons");end;
		if getXMLFloat(Xml, groupNameTag.. "#zoomOutIn") then moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp = getXMLFloat(Xml, groupNameTag.. "#zoomOutIn");end;
		if not moGeneralSettings.ignore.maxZoomOutIn and moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp > moSetGetOverlays.pda[whichSubPDA].maxZoomOutInTemp then moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp = moSetGetOverlays.pda[whichSubPDA].maxZoomOutInTemp;end;
		if not moGeneralSettings.ignore.minZoomOutIn and moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp < moSetGetOverlays.pda[whichSubPDA].minZoomOutInTemp then moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp = moSetGetOverlays.pda[whichSubPDA].minZoomOutInTemp;end;		
		--zoom replace
		moSetGetOverlays.pda[whichSubPDA].pos.y = 0.999-(moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*4);
		moSetGetOverlays.pda[whichSubPDA].defaultUp.posY = 0.999-(moSetGetOverlays.buttonGfxHeight1*moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp*4);		
		--zoom replace
		if getXMLInt(Xml, groupNameTag.. "#viewLines") then 
			moSetGetOverlays.pda[whichSubPDA].viewLines = getXMLInt(Xml, groupNameTag.. "#viewLines");
			if not moGeneralSettings.ignore.maxViewLines and moSetGetOverlays.pda[whichSubPDA].viewLines > moSetGetOverlays.pda[whichSubPDA].maxViewLines then moSetGetOverlays.pda[whichSubPDA].viewLines = moSetGetOverlays.pda[whichSubPDA].maxViewLines;end;
		end;
		if getXMLInt(Xml, groupNameTag.. "#viewApps") then 
			moSetGetOverlays.pda[whichSubPDA].viewApps = getXMLInt(Xml, groupNameTag.. "#viewApps");
			if not moGeneralSettings.ignore.maxViewApps and moSetGetOverlays.pda[whichSubPDA].viewApps > moSetGetOverlays.pda[whichSubPDA].maxViewApps then moSetGetOverlays.pda[whichSubPDA].viewApps = moSetGetOverlays.pda[whichSubPDA].maxViewApps;end;
		end;
		if getXMLInt(Xml, groupNameTag.. "#appLines") then 
			local line = getXMLInt(Xml, groupNameTag.. "#appLines");
			if line == 0 then line = 1;end;
			if moSetGetOverlays.pda[whichSubPDA].line ~= nil then moSetGetOverlays.pda[whichSubPDA].line = {};end;
			if moSetGetOverlays.pda[whichSubPDA].renderViewLines ~= nil then moSetGetOverlays.pda[whichSubPDA].renderViewLines = {};end;
			local foundViewLine = 1;
			for a=1, line do
				groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a)); --.. "(%d)"):format(a-1);
				if groupNameTag == nil then break;end;
				moSetGetOverlays.pda[whichSubPDA].line[a] = {};
				if foundViewLine <= moSetGetOverlays.pda[whichSubPDA].viewLines then 
					moSetGetOverlays.pda[whichSubPDA].line[a].view = true;
					foundViewLine = foundViewLine+1;
					table.insert(moSetGetOverlays.pda[whichSubPDA].renderViewLines, a);
				else
					moSetGetOverlays.pda[whichSubPDA].line[a].view = false;
				end;
				
				--if getXMLBool(Xml, groupNameTag.. "#view") ~= nil then 
				--	moSetGetOverlays.pda[whichSubPDA].line[a].view = getXMLBool(Xml, groupNameTag.. "#view");
				--else
				--	moSetGetOverlays.pda[whichSubPDA].line[a].view = false;
				--end;
				--if moSetGetOverlays.pda[whichSubPDA].line[a].view then
				--	foundViewLine = foundViewLine+1;				
				--end;
				--if foundViewLine > moSetGetOverlays.pda[whichSubPDA].viewLines then moSetGetOverlays.pda[whichSubPDA].line[a].view = false;end;
				if getXMLInt(Xml, groupNameTag.. "#appSelect") then moSetGetOverlays.pda[whichSubPDA].line[a].appSelect = getXMLInt(Xml, groupNameTag.. "#appSelect");end;				
				if getXMLInt(Xml, groupNameTag.. "#appsAtLine") then 
					moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine = getXMLInt(Xml, groupNameTag.. "#appsAtLine");				
					if not moGeneralSettings.ignore.maxAppsAtLine and moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine > moSetGetOverlays.pda[whichSubPDA].maxAppsAtLine then moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine = moSetGetOverlays.pda[whichSubPDA].maxAppsAtLine;end;
					if moSetGetOverlays.pda[whichSubPDA].line[a].appSelect > moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine then moSetGetOverlays.pda[whichSubPDA].line[a].appSelect = 1;end;
					moSetGetOverlays.pda[whichSubPDA].line[a].appSettingSelect=moSetGetOverlays.pda[whichSubPDA].line[a].appSelect;
					for b=1, moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine do
						local groupNameTagTemp = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a).. ".app".. tostring(b));
						if groupNameTagTemp == nil then break;end;
						if moSetGetOverlays.pda[whichSubPDA].line[a].app == nil then moSetGetOverlays.pda[whichSubPDA].line[a].app = {};end;
						moSetGetOverlays.pda[whichSubPDA].line[a].app[b] = {};
						if getXMLInt(Xml, groupNameTagTemp.. "#iconTyp") then 
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconTyp = getXMLInt(Xml, groupNameTagTemp.. "#iconTyp");						
						else
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconTyp = 1;
						end;
						if getXMLBool(Xml, groupNameTagTemp.. "#openMarker") then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].openMarker = getXMLBool(Xml, groupNameTagTemp.. "#openMarker");else moSetGetOverlays.pda[whichSubPDA].line[a].app[b].openMarker = false;end;						
						if getXMLString(Xml, groupNameTagTemp.. "#iconName") then 
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName = getXMLString(Xml, groupNameTagTemp.. "#iconName");
						else
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName = "mohIconBlank_";
						end;
						
						moSetGetOverlays:loadAppIconsOverlays(self, moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName, moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconTyp, nil, nil, whichSubPDA);						
						local iconTxt = nil;						
						if getXMLString(Xml, groupNameTagTemp.. "#iconText") then iconTxt = getXMLString(Xml, groupNameTagTemp.. "#iconText");end;						
						if iconTxt ~= nil and string.len(iconTxt) > 0 and moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName] ~= nil then
							if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4 == nil then moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4 = {};end;
							moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.txt = iconTxt;
							if getXMLString(Xml, groupNameTagTemp.. "#colorText") then																	
								local colorString = getXMLString(Xml, groupNameTagTemp.. "#colorText");								
								moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.color = colorString;								
							end;
							if getXMLFloat(Xml, groupNameTagTemp.. "#iconTextSize") then
								moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.size = getXMLFloat(Xml, groupNameTagTemp.. "#iconTextSize");
							end;
							if getXMLBool(Xml, groupNameTagTemp.. "#iconTextBold") then
								moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.bold = getXMLBool(Xml, groupNameTagTemp.. "#iconTextBold");
							end;
						end;						
						if moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconTyp == 5 and moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName] ~= nil then
							local category = nil;
							local categoryTyp = nil;
							if getXMLString(Xml, groupNameTagTemp.. "#category") then category = getXMLString(Xml, groupNameTagTemp.. "#category");end;
							if getXMLInt(Xml, groupNameTagTemp.. "#categoryTyp") then categoryTyp = getXMLInt(Xml, groupNameTagTemp.. "#categoryTyp");end;
							if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5 == nil then moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5 = {};end;
							if category ~= nil and categoryTyp ~= nil then
								moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.category = category;
								moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.categoryTyp = categoryTyp;
							end;
						end;
						if moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd == nil then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd = {};end;
						for c=1, moGeneralSettings.maxCmd do
							local groupNameTagCmd = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a).. ".app".. tostring(b).. ".cmd".. tostring(c));
							if groupNameTagCmd == nil or not getXMLString(Xml, groupNameTagCmd.. "#name") then break;end;							
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c] = {};
							if getXMLString(Xml, groupNameTagCmd.. "#name") then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].name = getXMLString(Xml, groupNameTagCmd.. "#name");end;
							if getXMLString(Xml, groupNameTagCmd.. "#from") then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].from = getXMLString(Xml, groupNameTagCmd.. "#from");end;
							if getXMLString(Xml, groupNameTagCmd.. "#fromRealName") then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].fromRealName = getXMLString(Xml, groupNameTagCmd.. "#fromRealName");end;
							moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click = {mouseButtonLeft=false, mouseButtonMiddle=false, mouseButtonRight=false, key=false};
							if getXMLString(Xml, groupNameTagCmd.. "#clickTyp") then 
								local clickLoadXml = getXMLString(Xml, groupNameTagCmd.. "#clickTyp");
								local click, isOkay = MultiOverlayV3:get_hl("stringSplit", {clickLoadXml, " "}, "moSetGetClientSettings Load ClickTyp XML/String Split"); --args hl table, argsTable a table with all args Values, errorTxt a Value for debug print
								if isOkay then
									if click[1] == "true" then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonLeft = true;else moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonLeft = false;end;
									if click[2] == "true" then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonMiddle = true;else moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonMiddle = false;end;
									if click[3] == "true" then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonRight = true;else moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonRight = false;end;
									if click[4] == "true" then moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.key = true;else moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.key = false;end;
								end;
							end;
						end;											
					end;					
				end;
			end;
		end;
		groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".pos");
		if not moSetGetOverlays.pda[whichSubPDA].pos.up then moSetGetOverlays.pda[whichSubPDA].pos.x = moSetGetOverlays.pda[whichSubPDA].defaultDown.posX;moSetGetOverlays.pda[whichSubPDA].pos.y = moSetGetOverlays.pda[whichSubPDA].defaultDown.posY;end;
		if getXMLFloat(Xml, groupNameTag.. "#posX") then moSetGetOverlays.pda[whichSubPDA].manuPosX = getXMLFloat(Xml, groupNameTag.. "#posX");end;
		if getXMLFloat(Xml, groupNameTag.. "#posY") then moSetGetOverlays.pda[whichSubPDA].manuPosY = getXMLFloat(Xml, groupNameTag.. "#posY");end;		
		if moSetGetOverlays.pda[whichSubPDA].manuPosY <= 0 and moSetGetOverlays.pda[whichSubPDA].manuPosX <= 0 then 
			moSetGetOverlays.pda[whichSubPDA].manuPosY = nil;moSetGetOverlays.pda[whichSubPDA].manuPosX = nil;
		else
			--moSetGetOverlays.pda[whichSubPDA].pos.x = moSetGetOverlays.pda[whichSubPDA].manuPosX;
			--moSetGetOverlays.pda[whichSubPDA].pos.y = moSetGetOverlays.pda[whichSubPDA].manuPosY;
			moSetGetOverlays.pda[whichSubPDA].autoPosMiddle = false;
		end;
		if getXMLBool(Xml, groupNameTag.. "#autoPosMiddle") ~= nil then moSetGetOverlays.pda[whichSubPDA].autoPosMiddle = getXMLBool(Xml, groupNameTag.. "#autoPosMiddle");end;
		
		--generate default open/close cmd
		moSetGetCmd:generatePdaOpenCloseCmd(whichSubPDA);
		--generate default open/close cmd
		if moSetGetOverlays.appIcon[whichSubPDA] == nil then
			moSetGetOverlays:loadAppIconsOverlays(self, "mohIconBlank_", 0, nil, nil, whichSubPDA);
			moSetGetOverlays:loadAppIconsOverlays(self, "mohIconFail_", 1, nil, nil, whichSubPDA);			
		else
			if moSetGetOverlays.appIcon[whichSubPDA]["mohIconBlank_"] == nil then moSetGetOverlays:loadAppIconsOverlays(self, "mohIconBlank_", 0, nil, nil, whichSubPDA);end;
			if moSetGetOverlays.appIcon[whichSubPDA]["mohIconFail_"] == nil then moSetGetOverlays:loadAppIconsOverlays(self, "mohIconFail_", 1, nil, nil, whichSubPDA);end;	
		end;
		if moSetGetOverlays.pda[whichSubPDA].viewLines > #moSetGetOverlays.pda[whichSubPDA].line then 
			moSetGetOverlays.pda[whichSubPDA].viewLines = 1;
			local foundViewLine = false;
			for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
				if not foundViewLine then
					if moSetGetOverlays.pda[whichSubPDA].line[a].view then foundViewLine = true;end;
				else
					moSetGetOverlays.pda[whichSubPDA].line[a].view = false;
				end;
			end;
		end;
		--posXMiddle replace
		moSetGetOverlays:replacePdaPosX(self, whichSubPDA);		
		--posXMiddle replace
		--posY not up replace
		moSetGetOverlays:replacePdaPosY(self, whichSubPDA);
		--posY not up replace		
	end;	
end;

function loadSLOT(self, Xml, xmlNameTag, whichSLOT)
	local whichSubSLOT = whichSLOT;
	local groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. "(%d)"):format(0);
	if Xml ~= nil and groupNameTag ~= nil and getXMLString(Xml, groupNameTag.. "#name") ~= nil then
		if moSetGetOverlays.slot[whichSubSLOT] == nil then moSetGetOverlays.slot[whichSubSLOT] = MultiOverlayV3:getTableCopy(moSetGetOverlays.slotDefault);end;
		if getXMLString(Xml, groupNameTag.. "#name") then moSetGetOverlays.slot[whichSubSLOT].name = getXMLString(Xml, groupNameTag.. "#name");end;
		if getXMLBool(Xml, groupNameTag.. "#isOpen") ~= nil then moSetGetOverlays.slot[whichSubSLOT].isOpen = getXMLBool(Xml, groupNameTag.. "#isOpen");end;
		if getXMLInt(Xml, groupNameTag.. "#typ") then moSetGetOverlays.slot[whichSubSLOT].typ = getXMLInt(Xml, groupNameTag.. "#typ");end;
		if getXMLBool(Xml, groupNameTag.. "#autoClose") ~= nil then moSetGetOverlays.slot[whichSubSLOT].autoClose[1] = getXMLBool(Xml, groupNameTag.. "#autoClose");end;
		if getXMLInt(Xml, groupNameTag.. "#autoCloseTimer") then moSetGetOverlays.slot[whichSubSLOT].autoClose[2] = getXMLInt(Xml, groupNameTag.. "#autoCloseTimer");end;
		if getXMLBool(Xml, groupNameTag.. "#smallView") ~= nil then moSetGetOverlays.slot[whichSubSLOT].smallView = getXMLBool(Xml, groupNameTag.. "#smallView");end;
		if getXMLFloat(Xml, groupNameTag.. "#zoomOutIn") then moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp = getXMLFloat(Xml, groupNameTag.. "#zoomOutIn");end;
		if moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp > moSetGetOverlays.slot[whichSubSLOT].maxZoomOutInTemp then moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp = moSetGetOverlays.slot[whichSubSLOT].maxZoomOutInTemp;end;
		if moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp < moSetGetOverlays.slot[whichSubSLOT].minZoomOutInTemp then moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp = moSetGetOverlays.slot[whichSubSLOT].minZoomOutInTemp;end;
		
		groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".txt(%d)"):format(0);
		if getXMLFloat(Xml, groupNameTag.. "#size") then moSetGetOverlays.slot[whichSubSLOT].size = getXMLFloat(Xml, groupNameTag.. "#size");end;
		if getXMLFloat(Xml, groupNameTag.. "#distanceHorizontal") then moSetGetOverlays.slot[whichSubSLOT].horizontalTxtDistance = getXMLFloat(Xml, groupNameTag.. "#distanceHorizontal");end;
		if getXMLFloat(Xml, groupNameTag.. "#distanceVertical") then moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance = getXMLFloat(Xml, groupNameTag.. "#distanceVertical");end;
		if getXMLInt(Xml, groupNameTag.. "#widthFix") then moSetGetOverlays.slot[whichSubSLOT].txtWidthFix = getXMLInt(Xml, groupNameTag.. "#widthFix");end;
		if getXMLString(Xml, groupNameTag.. "#color") then	moSetGetOverlays.slot[whichSubSLOT].txtColor = getXMLString(Xml, groupNameTag.. "#color");end;
		if getXMLString(Xml, groupNameTag.. "#markerColor") then	moSetGetOverlays.slot[whichSubSLOT].txtMarkerColor = getXMLString(Xml, groupNameTag.. "#markerColor");end;
		
		groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".pos(%d)"):format(0);		
		if getXMLFloat(Xml, groupNameTag.. "#posX") then moSetGetOverlays.slot[whichSubSLOT].manuPosX = getXMLFloat(Xml, groupNameTag.. "#posX");end;
		if moSetGetOverlays.slot[whichSubSLOT].manuPosX <= 0 then moSetGetOverlays.slot[whichSubSLOT].manuPosX = nil;end;
		if getXMLFloat(Xml, groupNameTag.. "#posY") then moSetGetOverlays.slot[whichSubSLOT].manuPosY = getXMLFloat(Xml, groupNameTag.. "#posY");end;
		if moSetGetOverlays.slot[whichSubSLOT].manuPosY <= 0 then moSetGetOverlays.slot[whichSubSLOT].manuPosY = nil;end;
		moSetGetOverlays:loadSlotOverlays(self, nil, whichSubSLOT);
		if getXMLFloat(Xml, groupNameTag.. "#width") then 
			local width = getXMLFloat(Xml, groupNameTag.. "#width");
			if width > moSetGetOverlays.slot[whichSubSLOT].defaultWidth then moSetGetOverlays.slot[whichSubSLOT].width = width;end;
		end;
		if getXMLFloat(Xml, groupNameTag.. "#height") then 
			local height = getXMLFloat(Xml, groupNameTag.. "#height");
			if height > moSetGetOverlays.slot[whichSubSLOT].defaultHeight then moSetGetOverlays.slot[whichSubSLOT].height = height;end;
		end;
		if moSetGetOverlays.slot[whichSubSLOT].cmd == nil then moSetGetOverlays.slot[whichSubSLOT].cmd = {};end;
		local cmd=1;
		while true do
			local groupNameTagCmd = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".cmd".. tostring(cmd));
			if groupNameTagCmd == nil or not getXMLString(Xml, groupNameTagCmd.. "#name") then break;end;
			moSetGetOverlays.slot[whichSubSLOT].cmd[cmd] = {};
			if getXMLString(Xml, groupNameTagCmd.. "#name") then moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].name = getXMLString(Xml, groupNameTagCmd.. "#name");end;
			if getXMLString(Xml, groupNameTagCmd.. "#from") then moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].from = getXMLString(Xml, groupNameTagCmd.. "#from");end;
			if getXMLString(Xml, groupNameTagCmd.. "#fromRealName") then moSetGetOverlays.slot[whichSubSLOT].cmd[cmd].fromRealName = getXMLString(Xml, groupNameTagCmd.. "#fromRealName");end;
			cmd = cmd+1;
		end;
		moSetGetCmd:generateSlotOpenCloseCmd(whichSubSLOT);
		moSetGetMohSLOT:resetRenderViewLines(whichSubSLOT);
		moSetGetMohSLOT:resetRenderViewText(whichSubSLOT);
	end;
end;

function moSetGetClientSettings:saveConfig(self)
	local file = MultiOverlayV3.settingsDir.. "clientSettings.xml";
	local saveFile = MultiOverlayV3.saveGameDir.. "clientSettings.xml";
	if fileExists(saveFile) then file = saveFile;end;
	local Xml = createXMLFile("MultiOverlayV3_XML", file, "clientSettings");
	local xmlNameTag = "clientSettings";
	if Xml ~= nil then
		--other settings
		local groupNameTag = (xmlNameTag.. ".other(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#miniMapAutoState0", moGeneralSettings.other.miniMapAutoState0);
		setXMLBool(Xml, groupNameTag.. "#playerPos", moGeneralSettings.playerPos);
		--other settings
		--wtm settings
		groupNameTag = (xmlNameTag.. ".wtm(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#weatherBox", MultiOverlayV3.wtm.weatherBox);
		setXMLBool(Xml, groupNameTag.. "#moneyBox", MultiOverlayV3.wtm.showMoney);
		setXMLBool(Xml, groupNameTag.. "#timeBox", MultiOverlayV3.wtm.showTime);
		setXMLBool(Xml, groupNameTag.. "#stateBox", MultiOverlayV3.wtm.stateBox);
		setXMLBool(Xml, groupNameTag.. "#seasonBox", MultiOverlayV3.wtm.seasonBox);
		setXMLBool(Xml, groupNameTag.. "#temperatureBox", MultiOverlayV3.wtm.temperatureBox);
		--wtm settings
		--side notifications
		groupNameTag = (xmlNameTag.. ".sideNotifications(%d)"):format(0);
		setXMLInt(Xml, groupNameTag.. "#viewMax", moGeneralSettings.sideNotifications.viewMax);
		setXMLInt(Xml, groupNameTag.. "#upDownFix", moGeneralSettings.sideNotifications.upDownFix);
		setXMLInt(Xml, groupNameTag.. "#duration", moGeneralSettings.sideNotifications.duration);
		--side notifications
		--global mod
		groupNameTag = (xmlNameTag.. ".global.mod(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#on", moGeneralSettings.modOn);		
		setXMLBool(Xml, groupNameTag.. "#mouseOnAndFrozen", moGeneralSettings.setFrozen);
		setXMLBool(Xml, groupNameTag.. "#screenAspectRatioAuto", moGeneralSettings.screenAspectRatioAuto);
		setXMLInt(Xml, groupNameTag.. "#screenAspectRatio", moSetGetOverlays.screenAspectRatio);
		setXMLBool(Xml, groupNameTag.. "#backupClientSetting", moGeneralSettings.backupSettings.clientSetting);
		setXMLBool(Xml, groupNameTag.. "#backupAppSetting", moGeneralSettings.backupSettings.appSetting);
		setXMLBool(Xml, groupNameTag.. "#deleteConfirm", moGeneralSettings.deleteConfirm);
		setXMLBool(Xml, groupNameTag.. "#mouseCursorAutoOff", moGeneralSettings.autoMouseCursor.off);
		setXMLInt(Xml, groupNameTag.. "#mouseCursorOffTimer", moGeneralSettings.autoMouseCursor.timer);
		setXMLBool(Xml, groupNameTag.. "#hlDebugMode", MultiOverlayV3.hlDebugMode);			
		--global mod
		
		--global PDAs
		groupNameTag = (xmlNameTag.. ".global.pda(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#invisible", moGeneralSettings.invisible.pdas);
		local pdaTotal = 0;
		local pdaNamen = "";		
		if moGeneralSettings.ignore.maxViewLinesXml then setXMLBool(Xml, groupNameTag.. "#ignoreMaxViewLines", true);end;
		if moGeneralSettings.ignore.maxViewAppsXml then setXMLBool(Xml, groupNameTag.. "#ignoreMaxViewApps", true);end;
		if moGeneralSettings.ignore.maxAppsAtLineXml then setXMLBool(Xml, groupNameTag.. "#ignoreMaxAppsAtLine", true);end;
		if moGeneralSettings.ignore.maxZoomOutInXml then setXMLBool(Xml, groupNameTag.. "#ignoreMaxZoomOutIn", true);end;
		if moGeneralSettings.ignore.minZoomOutInXml then setXMLBool(Xml, groupNameTag.. "#ignoreMinZoomOutIn", true);end;		
		for whichPDA, value in pairs(moSetGetOverlays.pda) do			
			pdaTotal = pdaTotal+1;			
			if pdaTotal <= 1 then
				pdaNamen = tostring(whichPDA);
			else
				pdaNamen = pdaNamen.. ",".. tostring(whichPDA);
			end;
			if moSetGetOverlays.pda[whichPDA] ~= nil then
				savePDA(self, Xml, xmlNameTag, whichPDA);
			end;
		end;		
		if string.len(pdaNamen) < 10 then pdaNamen = "masterPDA_";pdaTotal=1;end;
		setXMLInt(Xml, groupNameTag.. "#pdaTotal", pdaTotal);
		setXMLString(Xml, groupNameTag.. "#pdaNamen", pdaNamen);
		--global PDAs
		
		--global SLOTs
		groupNameTag = (xmlNameTag.. ".global.slot(%d)"):format(0);
		setXMLBool(Xml, groupNameTag.. "#invisible", moGeneralSettings.invisible.slots);
		local slotTotal = 0;
		local slotNamen = "";
		for whichSLOT, value in pairs(moSetGetOverlays.slot) do			
			slotTotal = slotTotal+1;			
			if slotTotal <= 1 then
				slotNamen = tostring(whichSLOT);
			else
				slotNamen = slotNamen.. ",".. tostring(whichSLOT);
			end;
			if moSetGetOverlays.slot[whichSLOT] ~= nil then
				saveSLOT(self, Xml, xmlNameTag, whichSLOT);
			end;
		end;		
		if string.len(slotNamen) < 11 then slotNamen = "masterSLOT_";slotTotal=1;end;
		setXMLInt(Xml, groupNameTag.. "#slotTotal", slotTotal);
		setXMLString(Xml, groupNameTag.. "#slotNamen", slotNamen);
		--global SLOTs
		--module
		moModule:saveConfigs(self, Xml, xmlNameTag);
		--module
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV3.metadata.title).. " save file error "..file);	
	end;	
end;

function saveSLOT(self, Xml, xmlNameTag, whichSLOT)
	local whichSubSLOT = whichSLOT;
	local groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. "(%d)"):format(0);
	if Xml ~= nil then
		setXMLString(Xml, groupNameTag.. "#name", moSetGetOverlays.slot[whichSubSLOT].name);
		setXMLBool(Xml, groupNameTag.. "#isOpen", moSetGetOverlays.slot[whichSubSLOT].isOpen);
		setXMLInt(Xml, groupNameTag.. "#typ", moSetGetOverlays.slot[whichSubSLOT].typ);
		setXMLBool(Xml, groupNameTag.. "#autoClose", moSetGetOverlays.slot[whichSubSLOT].autoClose[1]);
		setXMLInt(Xml, groupNameTag.. "#autoCloseTimer", moSetGetOverlays.slot[whichSubSLOT].autoClose[2]);
		setXMLBool(Xml, groupNameTag.. "#smallView", moSetGetOverlays.slot[whichSubSLOT].smallView);
		setXMLFloat(Xml, groupNameTag.. "#zoomOutIn", moSetGetOverlays.slot[whichSubSLOT].zoomOutInTemp);		
		
		groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".txt(%d)"):format(0);		
		setXMLFloat(Xml, groupNameTag.. "#size", moSetGetOverlays.slot[whichSubSLOT].size);		
		setXMLFloat(Xml, groupNameTag.. "#distanceHorizontal", moSetGetOverlays.slot[whichSubSLOT].horizontalTxtDistance);
		setXMLFloat(Xml, groupNameTag.. "#distanceVertical", moSetGetOverlays.slot[whichSubSLOT].verticalTxtDistance);
		setXMLInt(Xml, groupNameTag.. "#widthFix", moSetGetOverlays.slot[whichSubSLOT].txtWidthFix);		
		setXMLString(Xml, groupNameTag.. "#color", moSetGetOverlays.slot[whichSubSLOT].txtColor);		
		setXMLString(Xml, groupNameTag.. "#markerColor", moSetGetOverlays.slot[whichSubSLOT].txtMarkerColor);
		
		groupNameTag = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".pos(%d)"):format(0);
		if moSetGetOverlays.slot[whichSubSLOT].manuPosX ~= nil then
			setXMLFloat(Xml, groupNameTag.. "#posX", moSetGetOverlays.slot[whichSubSLOT].manuPosX);
		else
			setXMLFloat(Xml, groupNameTag.. "#posX", 0.00000);
		end;
		if moSetGetOverlays.slot[whichSubSLOT].manuPosY ~= nil then
			setXMLFloat(Xml, groupNameTag.. "#posY", moSetGetOverlays.slot[whichSubSLOT].manuPosY);
		else
			setXMLFloat(Xml, groupNameTag.. "#posY", 0.00000);
		end;
		setXMLFloat(Xml, groupNameTag.. "#width", moSetGetOverlays.slot[whichSubSLOT].width);
		setXMLFloat(Xml, groupNameTag.. "#height", moSetGetOverlays.slot[whichSubSLOT].height);
		
		if moSetGetOverlays.slot[whichSubSLOT].cmd ~= nil and #moSetGetOverlays.slot[whichSubSLOT].cmd > 0 then
			for c=1, #moSetGetOverlays.slot[whichSubSLOT].cmd do 
				local groupNameTagCmd = (xmlNameTag.. ".slot.".. tostring(whichSubSLOT).. ".cmd".. tostring(c));
				if groupNameTagCmd == nil then break;end;
				setXMLString(Xml, groupNameTagCmd.. "#name", tostring(moSetGetOverlays.slot[whichSubSLOT].cmd[c].name));
				setXMLString(Xml, groupNameTagCmd.. "#from", tostring(moSetGetOverlays.slot[whichSubSLOT].cmd[c].from));
				setXMLString(Xml, groupNameTagCmd.. "#fromRealName", tostring(moSetGetOverlays.slot[whichSubSLOT].cmd[c].fromRealName));
			end;
		end;
		moSetGetOverlays.slot[whichSubSLOT].save = true;
	end;
end;

function savePDA(self, Xml, xmlNameTag, whichPDA)
	local whichSubPDA = whichPDA;
	local groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. "(%d)"):format(0);
	if Xml ~= nil then		
		setXMLString(Xml, groupNameTag.. "#name", moSetGetOverlays.pda[whichSubPDA].name);
		if not string.find(whichSubPDA, "masterPDA_") then
			setXMLBool(Xml, groupNameTag.. "#isOpen", moSetGetOverlays.pda[whichSubPDA].isOpen);
		end;
		setXMLBool(Xml, groupNameTag.. "#autoClose", moSetGetOverlays.pda[whichSubPDA].autoClose);
		setXMLBool(Xml, groupNameTag.. "#autoOpenCloseSettings", moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings);
		setXMLBool(Xml, groupNameTag.. "#autoHidden", moSetGetOverlays.pda[whichSubPDA].hidden.auto);
		setXMLInt(Xml, groupNameTag.. "#hiddenTimer", moSetGetOverlays.pda[whichSubPDA].hidden.timer);
		--setXMLBool(Xml, groupNameTag.. "#smallView", moSetGetOverlays.pda[whichSubPDA].smallView);
		setXMLBool(Xml, groupNameTag.. "#keyControl", moSetGetOverlays.pda[whichSubPDA].keyControl);		
		setXMLInt(Xml, groupNameTag.. "#keySelectLine", moSetGetOverlays.pda[whichSubPDA].keySelect.line);
		setXMLInt(Xml, groupNameTag.. "#keySelectApp", moSetGetOverlays.pda[whichSubPDA].keySelect.app);		
		
		groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".pos");
		if moSetGetOverlays.pda[whichSubPDA].manuPosX ~= nil then
			setXMLFloat(Xml, groupNameTag.. "#posX", moSetGetOverlays.pda[whichSubPDA].manuPosX);
		else
			setXMLFloat(Xml, groupNameTag.. "#posX", 0.00000);
		end;
		if moSetGetOverlays.pda[whichSubPDA].manuPosY ~= nil then
			setXMLFloat(Xml, groupNameTag.. "#posY", moSetGetOverlays.pda[whichSubPDA].manuPosY);
		else
			setXMLFloat(Xml, groupNameTag.. "#posY", 0.00000);
		end;
		setXMLBool(Xml, groupNameTag.. "#autoPosMiddle", moSetGetOverlays.pda[whichSubPDA].autoPosMiddle);
		
		groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".design");
		setXMLInt(Xml, groupNameTag.. "#groundDesign", moSetGetOverlays.pda[whichSubPDA].groundDesign);
		setXMLInt(Xml, groupNameTag.. "#appLines", #moSetGetOverlays.pda[whichSubPDA].line);
		setXMLInt(Xml, groupNameTag.. "#viewLines", moSetGetOverlays.pda[whichSubPDA].viewLines);
		setXMLInt(Xml, groupNameTag.. "#viewApps", moSetGetOverlays.pda[whichSubPDA].viewApps);
		setXMLFloat(Xml, groupNameTag.. "#zoomOutIn", moSetGetOverlays.pda[whichSubPDA].zoomOutInTemp); 		
		setXMLFloat(Xml, groupNameTag.. "#distanceAppIcons", moSetGetOverlays.pda[whichSubPDA].distanceAppIcons);
		--local firstValue = false;
		if #moSetGetOverlays.pda[whichSubPDA].line > 0 then
			for a=1, #moSetGetOverlays.pda[whichSubPDA].line do
				groupNameTag = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a)); --.. "(%d)"):format(a-1);
				if groupNameTag == nil then break;end;
				setXMLBool(Xml, groupNameTag.. "#view", moSetGetOverlays.pda[whichSubPDA].line[a].view);
				setXMLInt(Xml, groupNameTag.. "#appsAtLine", moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine);
				setXMLInt(Xml, groupNameTag.. "#appSelect", moSetGetOverlays.pda[whichSubPDA].line[a].appSelect);			
				if moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine == 0 then break;end;
				for b=1, moSetGetOverlays.pda[whichSubPDA].line[a].appsAtLine do
					local groupNameTagTemp = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a).. ".app".. tostring(b));
					setXMLInt(Xml, groupNameTagTemp.. "#iconTyp", moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconTyp);				
					setXMLString(Xml, groupNameTagTemp.. "#iconName", moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName);
					
					if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4 ~= nil then
						if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.txt ~= nil then
							setXMLString(Xml, groupNameTagTemp.. "#iconText", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.txt);
							if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.color ~= nil then								
								setXMLString(Xml, groupNameTagTemp.. "#colorText", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.color);
							end;
							if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.size ~= nil then								
								setXMLFloat(Xml, groupNameTagTemp.. "#iconTextSize", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.size);
							end;
							if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.bold ~= nil then								
								setXMLBool(Xml, groupNameTagTemp.. "#iconTextBold", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ4.bold);
							end;
						end;
					end;
					if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5 ~= nil then
						if moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.category ~= nil and moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.categoryTyp ~= nil then
							setXMLString(Xml, groupNameTagTemp.. "#category", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.category);
							setXMLInt(Xml, groupNameTagTemp.. "#categoryTyp", moSetGetOverlays.appIcon[whichSubPDA][moSetGetOverlays.pda[whichSubPDA].line[a].app[b].iconName].typTable.typ5.categoryTyp);
						end;
					end;
					if moSetGetOverlays.pda[whichSubPDA].line[a].app[b].openMarker ~= nil then setXMLBool(Xml, groupNameTagTemp.. "#openMarker", moSetGetOverlays.pda[whichSubPDA].line[a].app[b].openMarker);end;
					if moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd ~= nil and #moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd > 0 then
						for c=1, #moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd do 
							local groupNameTagCmd = (xmlNameTag.. ".pda.".. tostring(whichSubPDA).. ".line".. tostring(a).. ".app".. tostring(b).. ".cmd".. tostring(c));
							if groupNameTagCmd == nil then break;end; 
							setXMLString(Xml, groupNameTagCmd.. "#name", tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].name));
							setXMLString(Xml, groupNameTagCmd.. "#from", tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].from));
							setXMLString(Xml, groupNameTagCmd.. "#fromRealName", tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].fromRealName));
							setXMLString(Xml, groupNameTagCmd.. "#clickTyp", tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonLeft).. " ".. tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonMiddle).. " ".. tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.mouseButtonRight).. " ".. tostring(moSetGetOverlays.pda[whichSubPDA].line[a].app[b].cmd[c].click.key));
						end;						
					end;
				end;			
			end;
		end;
	end;	
end;

function moSetGetClientSettings:saveBackup(file, isSaveGameIndex)	
	local fileBackup = MultiOverlayV3.settingsDir.. "clientSettingsBackup.xml";
	if isSaveGameIndex then fileBackup = MultiOverlayV3.saveGameDir.. "clientSettingsBackup.xml";end;	
	if fileExists(file) then copyFile(file, fileBackup, true, true);end; --true, replace old file
	--getfenv(0).deleteFile(fileBackup)
end;